/* eek-0.1.vapi generated by vapigen, do not modify. */

[CCode (cprefix = "Eek", lower_case_cprefix = "eek_")]
namespace Eek {
	[Compact]
	[CCode (type_id = "EEK_TYPE_BOUNDS", cheader_filename = "eek/eek.h")]
	public class Bounds {
		public double height;
		public double width;
		public double x;
		public double y;
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public class Container : Eek.Element {
		[NoWrapper]
		public virtual void add_child (Eek.Element element);
		public virtual unowned Eek.Element find (Eek.CompareFunc func);
		public unowned Eek.Element find_by_position (double x, double y);
		public virtual void foreach_child (Eek.Callback callback);
		[NoWrapper]
		public virtual void remove_child (Eek.Element element);
		public virtual signal void child_added (Eek.Element element);
		public virtual signal void child_removed (Eek.Element element);
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public class Element : GLib.InitiallyUnowned {
		public void get_absolute_position (double x, double y);
		public virtual void get_bounds (Eek.Bounds bounds);
		public virtual unowned string get_name ();
		public virtual unowned Eek.Element get_parent ();
		public virtual void set_bounds (Eek.Bounds bounds);
		public virtual void set_name (string name);
		public virtual void set_parent (Eek.Element parent);
		public Eek.Bounds bounds { get; set; }
		public string name { get; set; }
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public class Key : Eek.Element {
		public virtual void get_index (int column, int row);
		public virtual uint get_keycode ();
		public virtual uint get_keysym ();
		public virtual void get_keysym_index (int group, int level);
		public virtual void get_keysyms (uint keysyms, int num_groups, int num_levels);
		public virtual unowned Eek.Outline get_outline ();
		public virtual void set_index (int column, int row);
		public virtual void set_keycode (uint keycode);
		public virtual void set_keysym_index (int group, int level);
		public virtual void set_keysyms (uint keysyms, int num_groups, int num_levels);
		public virtual void set_outline (Eek.Outline outline);
		[NoAccessorMethod]
		public int column { get; set; }
		[NoAccessorMethod]
		public int group { get; set; }
		public uint keycode { get; set; }
		public Eek.KeysymMatrix keysyms { get; set; }
		[NoAccessorMethod]
		public int level { get; set; }
		public void* outline { get; set; }
		[NoAccessorMethod]
		public int row { get; set; }
		public virtual signal void pressed ();
		public virtual signal void released ();
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public class Keyboard : Eek.Container {
		public virtual unowned Eek.Section create_section ();
		public virtual unowned Eek.Key find_key_by_keycode (uint keycode);
		public virtual void get_keysym_index (int group, int level);
		public virtual void realize ();
		public virtual void set_keysym_index (int group, int level);
		public virtual void set_layout (Eek.Layout layout);
		[NoAccessorMethod]
		public int group { get; set; }
		[NoAccessorMethod]
		public int level { get; set; }
		public virtual signal void key_pressed (Eek.Key p0);
		public virtual signal void key_released (Eek.Key p0);
	}
	[Compact]
	[CCode (type_id = "EEK_TYPE_KEYSYM_MATRIX", cheader_filename = "eek/eek.h")]
	public class KeysymMatrix {
		public uint data;
		public int num_groups;
		public int num_levels;
	}
	[Compact]
	[CCode (type_id = "EEK_TYPE_OUTLINE", cheader_filename = "eek/eek.h")]
	public class Outline {
		public double corner_radius;
		public int num_points;
		public weak Eek.Point points;
	}
	[Compact]
	[CCode (type_id = "EEK_TYPE_POINT", cheader_filename = "eek/eek.h")]
	public class Point {
		public double x;
		public double y;
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public class Section : Eek.Container {
		public virtual void add_row (int num_columns, Eek.Orientation orientation);
		public virtual unowned Eek.Key create_key (int column, int row);
		public virtual unowned Eek.Key find_key_by_keycode (uint keycode);
		public virtual int get_angle ();
		public virtual int get_n_rows ();
		public virtual void get_row (int index, int num_columns, Eek.Orientation orientation);
		public virtual void set_angle (int angle);
		public int angle { get; set; }
		public virtual signal void key_pressed (Eek.Key p0);
		public virtual signal void key_released (Eek.Key p0);
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public interface Layout {
		public abstract void apply (Eek.Keyboard keyboard);
		public abstract int get_group ();
		public signal void changed ();
		public signal void group_changed (int group);
	}
	[CCode (cprefix = "EEK_KEYSYM_CATEGORY_", has_type_id = false, cheader_filename = "eek/eek.h")]
	public enum KeysymCategory {
		LETTER,
		FUNCTION,
		KEYNAME,
		UNKNOWN,
		LAST
	}
	[CCode (cprefix = "EEK_ORIENTATION_", has_type_id = false, cheader_filename = "eek/eek.h")]
	public enum Orientation {
		VERTICAL,
		HORIZONTAL,
		INVALID
	}
	[CCode (cheader_filename = "eek/eek.h")]
	public delegate void Callback (Eek.Element element);
	[CCode (cheader_filename = "eek/eek.h")]
	public delegate int CompareFunc (Eek.Element element);
	[CCode (cheader_filename = "eek/eek.h")]
	public const int CONTAINER_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int ELEMENT_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int KEYBOARD_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int KEYSYM_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int KEY_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int LAYOUT_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int SECTION_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public const int TYPES_H;
	[CCode (cheader_filename = "eek/eek.h")]
	public static Eek.KeysymCategory keysym_get_category (uint keysym);
	[CCode (cheader_filename = "eek/eek.h")]
	public static unowned string keysym_to_string (uint keysym);
}
